# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.owm_metrics import OwmMetrics  # noqa: F401,E501
from swagger_server import util


class OwmEditableParameters(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, metrics: List[OwmMetrics]=None, topic_name: str=None):  # noqa: E501
        """OwmEditableParameters - a model defined in Swagger

        :param metrics: The metrics of this OwmEditableParameters.  # noqa: E501
        :type metrics: List[OwmMetrics]
        :param topic_name: The topic_name of this OwmEditableParameters.  # noqa: E501
        :type topic_name: str
        """
        self.swagger_types = {
            'metrics': List[OwmMetrics],
            'topic_name': str
        }

        self.attribute_map = {
            'metrics': 'metrics',
            'topic_name': 'topic-name'
        }
        self._metrics = metrics
        self._topic_name = topic_name

    @classmethod
    def from_dict(cls, dikt) -> 'OwmEditableParameters':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The owm-editable-parameters of this OwmEditableParameters.  # noqa: E501
        :rtype: OwmEditableParameters
        """
        return util.deserialize_model(dikt, cls)

    @property
    def metrics(self) -> List[OwmMetrics]:
        """Gets the metrics of this OwmEditableParameters.

        List of the weather metrics to be retrieved by this datasource. If not specified, it will retrieve all the metrics.  # noqa: E501

        :return: The metrics of this OwmEditableParameters.
        :rtype: List[OwmMetrics]
        """
        return self._metrics

    @metrics.setter
    def metrics(self, metrics: List[OwmMetrics]):
        """Sets the metrics of this OwmEditableParameters.

        List of the weather metrics to be retrieved by this datasource. If not specified, it will retrieve all the metrics.  # noqa: E501

        :param metrics: The metrics of this OwmEditableParameters.
        :type metrics: List[OwmMetrics]
        """

        self._metrics = metrics

    @property
    def topic_name(self) -> str:
        """Gets the topic_name of this OwmEditableParameters.

        Kafka topic in which metrics of this datasource will be published. If empty the metrics will be published in a Kafka topic named according a predefined pattern.  # noqa: E501

        :return: The topic_name of this OwmEditableParameters.
        :rtype: str
        """
        return self._topic_name

    @topic_name.setter
    def topic_name(self, topic_name: str):
        """Sets the topic_name of this OwmEditableParameters.

        Kafka topic in which metrics of this datasource will be published. If empty the metrics will be published in a Kafka topic named according a predefined pattern.  # noqa: E501

        :param topic_name: The topic_name of this OwmEditableParameters.
        :type topic_name: str
        """

        self._topic_name = topic_name
